/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource['epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput'] = true;
/*
	Copyright (c) 2006-2010, epages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput $Revision: 1.9 $

*/
dojo.provide('epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput');
dojo.require('epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery');
dojo.require('epages.event');

dojo.declare("epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput",
	[epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery],
	{
		value              : '',	       // String - input field value
		name               : '',         // String - name of input field
		multiSelect        : "false",    // [readonly] Boolean - media gallery option: enable multiselect
		onApply            : undefined , // [protected] Function - media gallery onapply callback
		relativeToSiteRoot : 'false',    // Boolean - input value will be relative to the site path (epages.vars.SiteRoot)
		'class'            : '',

		templateString:"<span class=\"MediaGalleryInput ${class}\">\n  <input type=\"text\" readonly=\"readonly\" name=\"${name}\" value=\"${value}\" dojoAttachPoint=\"inputNode\" />\n  <span class=\"Button EnableHover\" dojoAttachPoint=\"clickNode\">\n    <span class=\"ButtonContainer\">{SelectFile}</span>\n  </span>\n  <i class=\"Sprite ico_s_remove ClickIcon\" dojoAttachPoint=\"removeNode\" style=\"visibility:hidden\"></i>\n</span>\n",
		_templateMapping : {
			'standard' : {templateString:"<span class=\"MediaGalleryInput ${class}\">\n  <input type=\"text\" readonly=\"readonly\" name=\"${name}\" value=\"${value}\" dojoAttachPoint=\"inputNode\" />\n  <span class=\"Button EnableHover\" dojoAttachPoint=\"clickNode\">\n    <span class=\"ButtonContainer\">{SelectFile}</span>\n  </span>\n  <i class=\"Sprite ico_s_remove ClickIcon\" dojoAttachPoint=\"removeNode\" style=\"visibility:hidden\"></i>\n</span>\n"}
		},                               // [protected] Object - hash which associates templateType key with template filename

		postMixInProperties: function() {
		// summary: initalize values - adjust properites
			this.inherited("postMixInProperties", arguments);
			var mediagalleryInputScope = this;
			this.relativeToSiteRoot =  epages.string.toBoolean(this.relativeToSiteRoot);

			this.onApply = function(path) {
			// summary:
			//			media gallery onapply callback
			// items : epages.cartridges.de_epages.mediagallery.widget.Filelistitem[]
			//			list with possible itens
			// tags:
			//			callback
				mediagalleryInputScope.inputNode.value = path;
				epages.event.fire(mediagalleryInputScope.inputNode, 'change');
			};
		},

		postCreate: function() {
		// summary: adjust nodes and events
			this.inherited("postCreate", arguments);
			this.adjustRemoveNodeDisplay();
			this.connect(this.removeNode, 'onclick', 'removeValue');
			this.connect(this.inputNode, 'onchange', 'onChange');
		},

		onChange : function() {
		// summary: adjust display of remove node
			this.syncValue();
			this.adjustRemoveNodeDisplay();
		},

		adjustRemoveNodeDisplay: function() {
		// summary: adjust display of remove node
		// tags: protected
			if(this.value == "") {
				this.removeNode.style.visibility = "hidden";
			} else {
				this.removeNode.style.visibility = "";
			}
		},

		syncValue : function() {
		// summary: synch input value and this.value
		// tags: protected
			this.value = this.inputNode.value;
		},

		removeValue : function() {
		// summary: adjust display of remove node
		// tags: callback
			this.inputNode.value = "";
			epages.event.fire(this.inputNode, 'change');
		}

});

}
